/* Ofront 1.0 */

#ifndef Unix__h
#define Unix__h

#include "SYSTEM.h"

typedef
	SET Unix_FdSet[8];

typedef
	struct Unix_JmpBuf {
		LONGINT _prvt0;
		char _prvt1[396];
	} Unix_JmpBuf;

typedef
	CHAR *Unix_Name;

typedef
	struct Unix_Timeval {
		LONGINT sec, usec;
	} Unix_Timeval;

typedef
	struct Unix_Rusage {
		Unix_Timeval utime, stime;
		LONGINT maxrss, ixrss, ismrss, idrss, isrss, minflt, majflt, nswap, inblock, oublock, msgsnd, msgrcv, nsignals, nvcsw, nivcsw;
	} Unix_Rusage;

typedef
	struct Unix_SigContext {
		LONGINT onstack, mask, pc;
		LONGINT regs[32];
		LONGINT mdlo, mdhi, ownedfp;
		LONGINT fpregs[32];
		LONGINT fpccsr, fpceir, cause, badvaddr, badpaddr;
		LONGINT pad[8];
	} Unix_SigContext;

typedef
	Unix_SigContext *Unix_SigCtxPtr;

typedef
	struct Unix_SigStack {
		LONGINT sp, onstack;
	} Unix_SigStack;

typedef
	void (*Unix_SignalHandler)();

typedef
	struct Unix_SigVec {
		Unix_SignalHandler handle;
		SET mask, flags;
	} Unix_SigVec;

typedef
	struct Unix_Status {
		INTEGER dev;
		LONGINT ino;
		INTEGER mode, nlink, uid, gid, rdev;
		LONGINT size, atime, spare1, mtime, spare2, ctime, spare3, blksize, blocks, gennum, spare4;
	} Unix_Status;

typedef
	struct Unix_Timezone {
		LONGINT minuteswest, dsttime;
	} Unix_Timezone;



extern long *Unix_JmpBuf__typ;
extern long *Unix_Status__typ;
extern long *Unix_Timeval__typ;
extern long *Unix_Timezone__typ;
extern long *Unix_SigStack__typ;
extern long *Unix_SigContext__typ;
extern long *Unix_SigVec__typ;
extern long *Unix_Rusage__typ;

extern LONGINT Unix_errno();
extern void *Unix__init();

#define Unix_Chdir(path, path__len)	chdir(path)
#define Unix_Chmod(path, path__len, mode)	chmod(path, mode)
#define Unix_Close(fd)	close(fd)
#define Unix_Dup(fd)	dup(fd)
#define Unix_Dup2(fd1, fd2)	dup(fd1, fd2)
#define Unix_Exit(n)	exit(n)
#define Unix_Fchmod(fd, mode)	fchmod(fd, mode)
#define Unix_Flock(fd, operation)	flock(fd, operation)
#define Unix_Fstat(fd, statbuf, statbuf__typ)	fstat(fd, statbuf)
#define Unix_Fsync(fd)	fsync(fd)
#define Unix_Ftruncate(fd, length)	ftruncate(fd, length)
#define Unix_Getegid()	getegid()
#define Unix_Geteuid()	geteuid()
#define Unix_Getgid()	getgid()
#define Unix_Getpid()	getpid()
#define Unix_Gettimeofday(tv, tv__typ, tz, tz__typ)	gettimeofday(tv, tz)
#define Unix_Getuid()	getuid()
#define Unix_Ioctl(fd, request, arg)	ioctl(fd, request, arg)
#define Unix_Kill(pid, sig)	kill(pid, sig)
#define Unix_Lseek(fd, offset, origin)	lseek(fd, offset, origin)
#define Unix_Open(name, name__len, flag, mode)	open(name, flag, mode)
#define Unix_Read(fd, buf, nbyte)	read(fd, buf, nbyte)
#define Unix_ReadBlk(fd, buf, buf__len)	read(fd, buf, buf__len)
#define Unix_Readblk(fd, buf, buf__len, len)	read(fd, buf, len)
#define Unix_Rename(old, old__len, new, new__len)	rename(old, new)
#define Unix_Select(width, readfds, writefds, exceptfds, timeout, timeout__typ)	select(width, readfds, writefds, exceptfds, timeout)
#define Unix_Sigsetmask(mask)	sigsetmask(mask)
#define Unix_Stat(name, name__len, statbuf, statbuf__typ)	stat(name, statbuf)
#define Unix_Unlink(name, name__len)	unlink(name)
#define Unix_Write(fd, buf, nbyte)	write(fd, buf, nbyte)
#define Unix_WriteBlk(fd, buf, buf__len)	write(fd, buf, buf__len)

#endif
